package main

import (
	"fmt"
)

func ExampleMap() {
	// 声明
	var ages map[string]int
	fmt.Printf("%T %#v\n", ages, ages)
	fmt.Println(ages == nil) // 默认值为 nil

	// 字面值
	// ages = map[string]int{} // 定义空map
	ages = map[string]int{"xiaowang": 18} // 定义空map
	ages["xiaoming"] = 23
	fmt.Printf("%T %#v\n", ages, ages)

	//ages = make(map[string]int)
	//fmt.Printf("%T %#v\n", ages, ages) //map[string]int map[string]int{}

	// 操作
	fmt.Println(ages["xiaoming"])
	fmt.Println(ages["xianbin"]) // 不存在该值，默认为 int 的零值 0
	// 查
	age, ok := ages["xianbin"] // 判断是否存在，返回两个值，如存在获取 age, true，不存在 0, false
	if ok {
		fmt.Println(age)
	} else {
		fmt.Println("not exist")
	}

	if age, ok := ages["xianbin"]; ok {
		fmt.Println(age)
	} else {
		fmt.Println("not exist")
	}

	// 改
	ages["xiaoming"] = 22
	// 增
	ages["xianbin"] = 18
	fmt.Printf("%T %#v\n", ages, ages)

	// 删除
	delete(ages, "xianbin")
	delete(ages, "bin") // 删除key不存在的值
	fmt.Printf("%T %#v\n", ages, ages)

	// 获取长度
	fmt.Println(len(ages))

	// 遍历数组
	delete(ages, "xiaoming")
	for k, v := range ages {
		fmt.Println(k, v)
	}

	// Output:
	//map[string]int map[string]int(nil)
	//true
	//map[string]int map[string]int{"xiaoming":23, "xiaowang":18}
	//23
	//0
	//not exist
	//not exist
	//map[string]int map[string]int{"xianbin":18, "xiaoming":22, "xiaowang":18}
	//map[string]int map[string]int{"xiaoming":22, "xiaowang":18}
	//2
	//xiaowang 18
}

func main() {
	ExampleMap()
}
